//---------------------------------------------------------------------------//
//  MYLIBSQL.PRG
//
//  Author: Hector Pezoa - `HPGSOFT - 2007 -
//  Realizada con la libreria Ot4xb de Pablo Botella
//  Realized with the library Ot4xb of Pablo Botella   Get The Open Tools for Xbase++
//  here: http://www.xbwin.com
//
//  Version actualizada
//  Contents: PROTOTYPES FOR  LIBMYSQL.DLL
//---------------------------------------------------------------------------//
#include "dll.ch"
#include "ot4xb.ch"
#include "common.ch"
#INCLUDE "appevent.ch"
#INCLUDE "mysql.ch"
#INCLUDE "myerror.ch"
#INCLUDE "dcdialog.ch"


#PRAGMA LIBRARY( "ot4xb.LIB" )
 //-------------------------------------------------------------------------------------------------------------------------
//C:PROT: my_ulonglong mysql_affected_rows(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_affected_rows
DLL libmysql IMPORT mysql_affected_rows AS LONG ;
             PARAM  pMysql  AS POINTER32
// Aqui usamos LONG en lugar de DWORD para poder compararlo con -1 en caso de error
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: my_bool mysql_autocommit(MYSQL *mysql, my_bool mode)
// http://mysql.conclase.net/curso/index.php?api=mysql_autocommit
DLL libmysql IMPORT mysql_autocommit AS BOOL ;
             PARAM  pMysql  AS POINTER32 ,;
             PARAM  lMode    AS BOOL
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: my_bool mysql_change_user(MYSQL *mysql, const char *user, const char *password, const char *db)
// http://mysql.conclase.net/curso/index.php?api=mysql_change_user
DLL libmysql IMPORT mysql_change_user AS BOOL ;
             PARAM  pMysql  AS POINTER32 ,;
             PARAM  cUser   AS  LPSTR ,;
             PARAM  cPwd    AS  LPSTR ,;
             PARAM  cDbName AS  LPSTR
 //-------------------------------------------------------------------------------------------------------------------------
//C:PROT: const char *mysql_character_set_name(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_ set_name
DLL libmysql IMPORT mysql_character_set_name AS ZSTRING ;
             PARAM  pMysql  AS POINTER32

//-------------------------------------------------------------------------------------------------------------------------
//C_PROT:  void mysql_close(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_close
DLL libmysql IMPORT mysql_close AS VOID ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: my_bool mysql_commit(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_commit
DLL libmysql IMPORT mysql_commit AS BOOL ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
 // connect  - descontinuada
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: int mysql_create_db(MYSQL *mysql, const char *database)
// http://mysql.conclase.net/curso/index.php?api=mysql_create_db
DLL libmysql IMPORT mysql_create_db AS INT ;
             PARAM  pMysql  AS POINTER32 ,;
             PARAM  cDbName AS LPSTR
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT:  void mysql_data_seek(MYSQL_RES *result, my_ulonglong offset)
// http://mysql.conclase.net/curso/index.php?api=mysql_data_seek
DLL libmysql IMPORT mysql_data_seek AS VOID ;
             PARAM  pResult   AS POINTER32 ,;
             PARAM  qwOffset  AS QWORD
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT:  void mysql_debug(const char *debug)
// http://mysql.conclase.net/curso/index.php?api=mysql_debug
DLL libmysql IMPORT mysql_debug AS VOID  ;
             PARAM  debug      AS LPSTR
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: int mysql_drop_db(MYSQL *mysql, const char *db)
// http://mysql.conclase.net/curso/index.php?api=mysql_drop_db
DLL libmysql IMPORT mysql_drop_db AS INT32 ;
             PARAM  pMysql  AS POINTER32 ,;
             PARAM  db      AS LPSTR
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: int mysql_dump_debug_info(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_dump_debug_info
DLL libmysql IMPORT mysql_dump_debug_info AS INT32 ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: my_bool mysql_eof(MYSQL_RES *result)
// http://mysql.conclase.net/curso/index.php?api=mysql_eof
DLL libmysql IMPORT mysql_eof AS BOOL  ;
             PARAM  pResult   AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT:  unsigned int mysql_errno(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_errno
DLL libmysql IMPORT mysql_errno AS UINT ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: const char *mysql_error(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_error
DLL libmysql IMPORT mysql_error AS ZSTRING ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: MYSQL_FIELD *mysql_fetch_field(MYSQL_RES *result)
// http://mysql.conclase.net/curso/index.php?api=mysql_fetch_field
function mysql_fetch_field( pResult ) // oField
local QTEMPLATE qt AS  POINTER32 PARAM AS POINTER32
local pt := FpQCall( {"libmysql","mysql_fetch_field"},qt,pResult )
local oField
if pt == 0 ; return NIL ; end
oField := MYSQL_FIELD():New()
oField:_link_(pt,.F.)
return oField

//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: MYSQL_FIELD *mysql_fetch_fields(MYSQL_RES *result)
// http://mysql.conclase.net/curso/index.php?api=mysql_fetch_fields
function mysql_fetch_fields( pResult ) // -> aFields
local QTEMPLATE qt AS POINTER32 PARAM AS POINTER32
local pt   := FpQCall( {"libmysql","mysql_fetch_fields"},qt,pResult )
local aPt,aResult,nFields
if( pt == 0) ; return NIL ; end
nFields := mysql_num_fields( pResult )
aResult := Array( nFields )
aPt     := PeekDWord(pt,0,nFields)
aEval(aResult , {|e,n| aResult[n] := MYSQL_FIELD():New() , aResult[n]:_link_(aPt[n],.F.) } )
return aResult

//-------------------------------------------------------------------------------------------------------------------------

//C:PROT: MYSQL_FIELD *mysql_fetch_field_direct(MYSQL_RES *result, unsigned int fieldnr)
// http://mysql.conclase.net/curso/index.php?api=mysql_fetch_field_direct
function mysql_fetch_field_direct( pResult , nField ) // oField
local QTEMPLATE qt AS POINTER32 PARAM AS POINTER32 PARAM AS UINT
local pt := FpQCall( {"libmysql","mysql_fetch_field_direct"},qt,pResult , nField -1 )
local oField
if pt == 0 ; return NIL ; end
oField := MYSQL_FIELD():New()
oField:_link_(pt,.F.)
return oField
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: unsigned long *mysql_fetch_lengths(MYSQL_RES *result)
// http://mysql.conclase.net/curso/index.php?api=mysql_fetch_lengths
function mysql_fetch_lengths( pResult ) // -> aLen
local QTEMPLATE qt AS POINTER32 PARAM AS POINTER32
local pt := FpQCall( {"libmysql","mysql_fetch_lengths"},qt,pResult)
if pt == 0 ; return NIL ; end
return PeekDWord( pt,0, mysql_num_fields( pResult ) )
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT:  MYSQL_ROW mysql_fetch_row(MYSQL_RES *result)
// http://mysql.conclase.net/curso/index.php?api=mysql_fetch_row
function mysql_fetch_row( pResult ) // aRow AS POINTER32 ;
local QTEMPLATE qt AS POINTER32 PARAM AS POINTER32
local pt := FpQCall( {"libmysql","mysql_fetch_row"},qt,pResult)
local aSizes,aResul

if pt == 0 ; return NIL ; end
aSizes  := mysql_fetch_lengths( pResult )
aResult := PeekDWord( pt,0, Len(aSizes)) // Array of pointers
aEval(aResult , {|p,n| aResult[n] := iif(p==0,NIL,iif(aSizes[n]==0,"",PeekStr(p,0,aSizes[n]))) } )
return aResult

 //-------------------------------------------------------------------------------------------------------------------------
//C:PROT: unsigned int mysql_field_count(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_field_count
DLL libmysql IMPORT mysql_field_count AS UINT ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: MYSQL_FIELD_OFFSET mysql_field_seek(MYSQL_RES *result, MYSQL_FIELD_OFFSET offset)
// http://mysql.conclase.net/curso/index.php?api=mysql_field_seek
DLL libmysql IMPORT mysql_field_seek AS DWORD  ;
             PARAM  pResult   AS POINTER32    ,;
             PARAM  dwOffset  AS DWORD
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: MYSQL_FIELD_OFFSET mysql_field_tell(MYSQL_RES *result)
// http://mysql.conclase.net/curso/index.php?api=mysql_field_tell
DLL libmysql IMPORT mysql_field_tell AS DWORD;
             PARAM  pResult   AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: void mysql_free_result(MYSQL_RES *result)
// http://mysql.conclase.net/curso/index.php?api=mysql_free_result
DLL libmysql IMPORT mysql_free_result AS VOID ;
             PARAM  pResult   AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: char *mysql_get_client_info(void)
// http://mysql.conclase.net/curso/index.php?api=mysql_get_client_info
DLL libmysql IMPORT mysql_get_client_info AS ZSTRING
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT:  unsigned long mysql_get_client_version(void)
// http://mysql.conclase.net/curso/index.php?api=mysql_get_client_version
DLL libmysql IMPORT mysql_get_client_version AS ULONG
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: char *mysql_get_host_info(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_get_host_info
DLL libmysql IMPORT mysql_get_host_info AS ZSTRING ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT:  unsigned int mysql_get_proto_info(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_get_proto_info
DLL libmysql IMPORT mysql_get_proto_info AS UINT ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: char *mysql_get_server_info(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_get_server_info
DLL libmysql IMPORT mysql_get_server_info AS ZSTRING ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: unsigned long mysql_get_server_version(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_get_server_version
DLL libmysql IMPORT mysql_get_server_version AS ULONG  ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: unsigned long mysql_hex_string(char *to, const char *from, unsigned long length )
// http://mysql.conclase.net/curso/index.php?api=mysql_hex_string
function mysql_hex_string( cBinStr ) // -> cHexStr AS ULONG
local nLen := Len(cBinStr )
local p    := _xgrab( (nLen * 2) + 1 )
local cRet := PeekStr(p,0, nFpCall({"libmysql","mysql_hex_string"},p,cBinStr,nLen))
_xfree(p)
return cRet
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: char *mysql_info(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_info
DLL libmysql IMPORT mysql_info AS ZSTRING  ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C_PROT: MYSQL *mysql_init(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_init
DLL libmysql IMPORT mysql_init AS POINTER32 ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: my_ulonglong mysql_insert_id(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_insert_id
function mysql_insert_id( pMySql ) // oInt64  // LARGE_INTEGER object
local oo := LARGE_INTEGER():New()
oo:q := qwFpCall({"libmysql","mysql_insert_id"},pMySql)
return oo
//-------------------------------------------------------------------------------------------------------------------------
///C:PROT: int mysql_kill(MYSQL *mysql, unsigned long pid)
// http://mysql.conclase.net/curso/index.php?api=mysql_kill
DLL libmysql IMPORT mysql_kill AS INT    ;
             PARAM  pMysql  AS POINTER32 ,;
             PARAM  pId     AS ULONG
 //-------------------------------------------------------------------------------------------------------------------------
//C:PROT: void mysql_library_end(void)
// http://mysql.conclase.net/curso/index.php?api=mysql_library_end
DLL libmysql IMPORT mysql_library_end  AS VOID
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: int mysql_library_init(int argc, char **argv, char **groups)///   ver**
// http://mysql.conclase.net/curso/index.php?api=mysql_library_init
function mysql_library_init() // bOk
local n := nFpCall({"libmysql","mysql_library_init"},-1,Chrr(0,10),0)
return ( n == 0 )
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: MYSQL_RES *mysql_list_dbs(MYSQL *mysql, const char *wild)
// http://mysql.conclase.net/curso/index.php?api=mysql_list_dbs
DLL libmysql IMPORT mysql_list_dbs AS POINTER32 ;
             PARAM  pMysql  AS POINTER32 ,;
             PARAM  cWild   AS  LPSTR
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: MYSQL_RES *mysql_list_fields(MYSQL *mysql, const char *table, const char *wild)
// http://mysql.conclase.net/curso/index.php?api=mysql_list_fields
DLL libmysql IMPORT mysql_list_fields AS POINTER32 ;
             PARAM  pMysql  AS POINTER32 ,;
             PARAM  cTable  AS  LPSTR ,;
             PARAM  cWild   AS  LPSTR
//-------------------------------------------------------------------------------------------------------------------------
//C_PROT: MYSQL_RES *mysql_list_processes(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_list_processes
DLL libmysql IMPORT mysql_list_processes AS POINTER32 ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: MYSQL_RES *mysql_list_tables(MYSQL *mysql, const char *wild)
// http://mysql.conclase.net/curso/index.php?api=mysql_list_tables
DLL libmysql IMPORT mysql_list_tables AS POINTER32 ;
             PARAM  pMysql  AS POINTER32 ,;
             PARAM  cWild      AS  LPSTR
//-------------------------------------------------------------------------------------------------------------------
//C:PROT:  my_bool mysql_more_results(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_more_results
DLL libmysql IMPORT mysql_more_results AS BOOL ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: int mysql_next_result(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_next_result
DLL libmysql IMPORT mysql_next_result AS INT ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: unsigned int mysql_num_fields(MYSQL_RES *result)
// http://mysql.conclase.net/curso/index.php?api=mysql_num_fields
DLL libmysql IMPORT mysql_num_fields AS UINT ;
             PARAM  pResult   AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: my_ulonglong mysql_num_rows(MYSQL_RES *result)
// http://mysql.conclase.net/curso/index.php?api=mysql_num_rows
DLL libmysql IMPORT mysql_num_rows AS DWORD  ;
             PARAM  pResult   AS POINTER32

//C:PROT: my_ulonglong mysql_insert_id(MYSQL *mysql)                //ojoe
// http://mysql.conclase.net/curso/index.php?api=mysql_insert_id
//function mysql_insert_id( pMySql ) // oInt64  // LARGE_INTEGER object
//local oo := LARGE_INTEGER():New()
//oo:q := qwFpCall({"libmysql","mysql_insert_id"},pMySql)
//return oo
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: int mysql_options(MYSQL *mysql, enum mysql_option option, const char *arg)////pendiente
// http://mysql.conclase.net/curso/index.php?api=mysql_options
DLL libmysql IMPORT mysql_options AS INT  ;
             PARAM  pMysql  AS POINTER32 ,;
             PARAM  nOption AS INT ,;
             PARAM  cValue  AS LPSTR
// Note: If the value is numeric, must be packed with U2Bin()
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: int mysql_ping(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_ping
DLL libmysql IMPORT mysql_ping AS INT ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: int mysql_query(MYSQL *mysql, const char *query)
// http://mysql.conclase.net/curso/index.php?api=mysql_query
DLL libmysql IMPORT mysql_query AS INT    ;
             PARAM  pMysql  AS POINTER32 ,;
             PARAM  cQuery  AS LPSTR
//-------------------------------------------------------------------------------------------------------------------------
// MYSQL *mysql_real_connect(MYSQL *mysql, const char *host, const char *usuario, const char *password,
//    const char *database, unsigned int puerto, const char *unix_socket, unsigned long client_flag);
DLL libmysql IMPORT mysql_real_connect AS POINTER32 ;
             PARAM  pMysql      AS POINTER32 ,;
             PARAM  cHost       AS LPSTR     ,;
             PARAM  cUser       AS LPSTR     ,;
             PARAM  cPwd        AS LPSTR     ,;
             PARAM  cDbName     AS LPSTR     ,;
             PARAM  nPort       AS UINT      ,;
             PARAM  cPipeName   AS LPSTR     ,;
             PARAM  nFlags      AS ULONG

//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: unsigned long mysql_real_escape_string(MYSQL *mysql, char *to, const char *from, unsigned long length
// http://mysql.conclase.net/curso/index.php?api=mysql_real_escape_string
function mysql_real_escape_string( pMySql ,  cStr ) // -> cEscapedStr
local nLen := Len(cStr )
local p    := _xgrab( (nLen * 2) + 1 )
local cRet := PeekStr(p,0, nFpCall({"libmysql","mysql_real_escape_string"},pMySql,p,cStr,nLen))
_xfree(p)
return cRet
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT:  int mysql_real_query(MYSQL *mysql, const char *query, unsigned long length)
// http://mysql.conclase.net/curso/index.php?api=mysql_real_query
function mysql_real_query(pMySql,cQuery) // -> nResult
return nFpCall({"libmysql","mysql_real_query"},pMySql,cQuery,Len(cQuery))
//-------------------------------------------------------------------------------------------------------------------------

//C:PROT: int mysql_reload(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_reload
DLL libmysql IMPORT mysql_reload AS INT ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: my_bool mysql_rollback(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_rollback
DLL libmysql IMPORT mysql_rollback AS BOOL  ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: MYSQL_ROW_OFFSET mysql_row_seek(MYSQL_RES *result, MYSQL_ROW_OFFSET offset)
// http://mysql.conclase.net/curso/index.php?api=mysql_row_seek
DLL libmysql IMPORT mysql_row_seek AS DWORD  ;
             PARAM  pResult   AS POINTER32  ,;
             PARAM  dwOffset  AS DWORD

//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: MYSQL_ROW_OFFSET mysql_row_tell(MYSQL_RES *result)
// http://mysql.conclase.net/curso/index.php?api=mysql_row_tell
DLL libmysql IMPORT mysql_row_tell AS DWORD ;
             PARAM  pResult   AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT:  int mysql_select_db(MYSQL *mysql, const char *database)
// http://mysql.conclase.net/curso/index.php?api=mysql_select_db
DLL libmysql IMPORT mysql_select_db AS INT ;
             PARAM  pMysql  AS POINTER32 ,;
             PARAM  cDbName AS  LPSTR
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: int mysql_set_server_option(MYSQL *mysql, enum enum_mysql_set_option option)
// http://mysql.conclase.net/curso/index.php?api=mysql_set_server_option
DLL libmysql IMPORT mysql_set_server_option AS INT ;
             PARAM  pMysql  AS POINTER32 ,;
             PARAM  nOption AS INT
//-------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: int mysql_shutdown(MYSQL *mysql, enum enum_shutdown_level shutdown_level
// http://mysql.conclase.net/curso/index.php?api=mysql_shutdown
DLL libmysql IMPORT mysql_shutdown AS INT  ;
             PARAM  pMysql  AS POINTER32 ,;
             PARAM  nLevel  AS INT
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: const char *mysql_sqlstate(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_sqlstate
DLL libmysql IMPORT mysql_sqlstate AS ZSTRING ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
// int mysql_ssl_set(MYSQL *mysql, const char *key,
//  const char *cert, const char *ca, const char *capath, const char *cipher)
DLL libmysql IMPORT mysql_ssl_set    AS INT ;
             PARAM  pMysql           AS POINTER32 ,;
             PARAM  cKeyPath         AS LPSTR ,;
             PARAM  cCertPath        AS LPSTR ,;
             PARAM  cAuthorityPath   AS LPSTR ,;
             PARAM  cTrustedPEMPath  AS LPSTR ,;
             PARAM  cCipherList      AS LPSTR
//-------------------------------------------------------------------------------------------------------------------
//C:PROT: char *mysql_stat(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_stat
DLL libmysql IMPORT mysql_stat AS ZSTRING ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C_PROT:  MYSQL_RES *mysql_store_result(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_store_result
DLL libmysql IMPORT mysql_store_result AS POINTER32 ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C:PROT: unsigned long mysql_thread_id(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_thread_id
DLL libmysql IMPORT mysql_thread_id AS ULONG ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
//C_PROT: MYSQL_RES *mysql_use_result(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_use_result
DLL libmysql IMPORT mysql_use_result AS POINTER32  ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------

  //C:PROT: unsigned int mysql_warning_count(MYSQL *mysql)
// http://mysql.conclase.net/curso/index.php?api=mysql_warning_count
DLL libmysql IMPORT mysql_warning_count AS UINT ;
             PARAM  pMysql  AS POINTER32
//-------------------------------------------------------------------------------------------------------------------------
 Function Mysql_escape_string(unescaped_string)
 Local escaped_string
     escaped_string := Strtran(unescaped_string, "\\", "\\")
     escaped_string := Strtran(escaped_string, "'", "\'")

     escaped_string := Strtran(escaped_string, "`t", "\t")
     escaped_string := Strtran(escaped_string, "`n", "\n")
     escaped_string := Strtran(escaped_string, "`r", "\r")
     escaped_string := Strtran(escaped_string, "`b", "\b")

    // these characters appear to insert fine in mysql
    //escaped_string := Strtran(escaped_string, "%", "\%")
    //escaped_string := Strtran(escaped_string, "_", "\_")
    //escaped_string := Strtran(escaped_string, """", "\""")

     return escaped_string

//-------------------------------------------------------------------------------------------------------------------------
 Function MySQL_GetLastErrorNo(pMySql)
 return mysql_errno(pMySql)
//-------------------------------------------------------------------------------------------------------------------------
 Function MySQL_GetLastErrorMsg(pMySql)
 return   Mysql_error(pMySql)
//-------------------------------------------------------------------------------------------------------------------------
  /*
  Function MySQLError(pMySql, message)
  Local errorCode,errStr
   errorCode := mysql_errno(pMySql)
   errorStr :=  mysql_error(pMySql)
  // MsgBox(" MySQL Error: %message%, Error %errorCode%: %errorStr%`n`n%query% ")
   Return n
   Modificado por   Georg S. Lorrig
  */
  Function MySQLError(pMySql, message)
    Local errorCode, errorStr, dspmsg
    errorCode := mysql_errno(pMySql)
    errorStr :=  mysql_error(pMySql)
    dspmsg := " MySQL Error: %message%, Error %errorCode%:%errorStr%`n`n%query% "
    dspmsg := StrTran(dspmsg, "%message%", message)
    dspmsg := StrTran(dspmsg, "%errorCode%", LTrim(Str(errorCode)))
    dspmsg := StrTran(dspmsg, "%errorStr%", errorStr)
    dspmsg := StrTran(dspmsg, "`n", CRLF)
    MsgBox(dspmsg)
Return nil


//-----------------------------------------------------------------------------
FUNCTION  TipoField(nType,nLen,nDec)
local  lResp , cLen ,cDec
      IF nLen > 0
         cLen := ALLTRIM(STR(nLen))
      endif
      IF nDec > 0
         cDec := ALLTRIM(STR(nDec))
      ENDIF

       do case
        case nType ='N'
            if nDec =  0
                lResp =  "INT( " + clen +" )"
            else
              lResp :=  "DECIMAL( " + clen +" ," +cDec+ " )"
           endif
       case nType ='D'
             lResp = 'DATE'
       case nType = 'M'
             lResp = 'MEDIUMTEXT'
       case nType = 'L'
            lResp = 'CHAR(1)'
       otherwise
            lresp =   "CHAR( " + clen +" )"
     endcase

return lresp
 //-----------------------------------------------------------------------------

  FUNCTION InfoField(pResult)
  Local oField :=  mysql_fetch_field( pResult )
  Local aField :=  {}
  local cNombre,cTypexBase, nLargo, nDecimal,lFlags, cTypeMySql

   IF !empty(oField)
       cNombre    := oField:name
       aadd(aField,cNombre)
       cTypexBase := FieldType(oField:nType)
       aadd(aField,cTypexBase)
       nLargo     := oField:length
       aadd(aField,nLargo)
       nDecimal   := oField:decimals
       aadd(aField,nDecimal)
       lFlags     := oField:flags
       aadd(aField,lFlags)
       cTypeMySql := oField:nType
       aadd(aField, cTypeMySql)
 
   endif

return aField

//-----------------------------------------------------------------------------

FUNCTION FieldType(nNum)
local cTypeXbase := "U"

   if nNum >=0
      do case

         case nNum == MYSQL_TINY_TYPE
            cTypeXbase := "L"

         case nNum == MYSQL_SHORT_TYPE      .OR.;
              nNum == MYSQL_LONG_TYPE       .OR.;
              nNum == MYSQL_LONGLONG_TYPE   .OR.;
              nNum == MYSQL_FLOAT_TYPE      .OR.;
              nNum == MYSQL_DOUBLE_TYPE     .OR.;
              nNum == MYSQL_NULL_TYPE       .OR.;
              nNum == MYSQL_ENUMTYPE        .OR.;
              nNum == MYSQL_DECIMAL_TYPE    .OR.;
              nNum == MYSQL_INT24_TYPE      .OR.;
              nNum == MYSQL_YEAR_TYPE       .OR.;
              nNum == MYSQL_TIMESTAMP_TYPE
            cTypeXbase := "N"

         case nNum == MYSQL_DATE_TYPE
            cTypeXbase := "D"

         case nNum == MYSQL_TINY_BLOB_TYPE    .OR.;
              nNum == MYSQL_MEDIUM_BLOB_TYPE  .OR.;
              nNum == MYSQL_LONG_BLOB_TYPE    .OR.;
              nNum == MYSQL_BLOB_TYPE
              cTypeXbase := "M"

         case nNum == MYSQL_VAR_STRING_TYPE   .OR.;
              nNum == MYSQL_STRING_TYPE       .OR.;
              nNum == MYSQL_DATETIME_TYPE     .OR.;
              nNum == MYSQL_SET_TYPE          .OR.;
              nNum == MYSQL_TIME_TYPE         .OR.;
              nNum == MYSQL_NEWDATE_TYPE
            cTypeXbase := "C"

      endcase
   endif

return cTypeXbase
//-----------------------------------------------------------------------------
// Funcion de Manu Exposito
////////////////////////////////////
Function Muestra( a, cTitle )
local cTxt := ""
local n := len( a )
local i := 0
local e

    cTitle := if( empty( cTitle ), "Atencion", cTitle )

    if n > 0
        FOR i := 1 TO n
            e := if( a[ i ] == nil, "NULO", transform( a[ i ], "@" ) )
            cTxt += Chr(13)+Chr(10) + e
        NEXT
    else
        cTxt := "Array vacio"
    endif

    ?  'infor',cTxt, cTitle

return( nil )

//-----------------------------------------------------------------------------






//-------------------------------------------------------------------------------------------------------------------------
BEGIN STRUCTURE MYSQL_FIELD
  MEMBER DYNSZ   name                 // Name of column
  MEMBER DYNSZ   org_name             // Original column name, if an alias
  MEMBER DYNSZ   table                // Table of column if column was a field
  MEMBER DYNSZ   org_table            // Org table name, if table was an alias
  MEMBER DYNSZ   db                   // Database for table
  MEMBER DYNSZ   catalog                   // Catalog for table
  MEMBER DYNSZ   def                  // Default value (set by mysql_list_fields)
  MEMBER ULONG   length               // Width of column (create length)
  MEMBER ULONG   max_length           // Max width for selected set
  MEMBER LONG    name_length
  MEMBER LONG    org_name_length
  MEMBER LONG    table_length
  MEMBER LONG    org_table_length
  MEMBER LONG    db_length
  MEMBER LONG    catalog_length
  MEMBER LONG    def_length
  MEMBER LONG    flags                // Div flags
  MEMBER LONG    decimals             // Number of decimals in field
  MEMBER LONG    charsetnr            // Character set
  MEMBER LONG    nType                // Type of field. See mysql_com.h for types
END STRUCTURE
//-------------------------------------------------------------------------------------------------------------------------