///////////////////////////////////////////////////////////////////////////////
//     Author: Hector Pezoa - `HPGSOFT - 2007
//      Ejemplo de mantenimiento simple de una tabla
//      agregar, eliminar, modificar, avanzar, retroceder,  estilo EXPRESS
//
//    Example of simple maintenance of a table
//    add, delete,  modify, firs record, last record, etc  style EXPRESS
//
///////////////////////////////////////////////////////////////////////////////

#include "dcdialog.ch"     // version express

//-----------------------------------------------------------------------------
PROCEDURE DbeSys() ; Return
PROCEDURE AppSys() ; Return

#DEFINE     nCodigo    aApp[01]
#DEFINE     cNombre    aApp[02]
#DEFINE     cApellidos aApp[03]
#DEFINE     cDomicilio aApp[04]
#DEFINE     cPostal    aApp[05]
#DEFINE     cLocal     aApp[06]
#DEFINE     cProvincia aApp[07]
#DEFINE     lNew       aApp[08]
#DEFINE     lMod       aApp[09]


PROCEDURE Main()
LOCAL server   := 'LocalHost'
LOCAL username := 'root'
LOCAL password := ''
LOCAL cdb      := 'facturacion'
LOCAL cName    := 'clientes'
Local oTbl
local Gelist :=  {}
local aApp[15]

lNew := .f.
lMod := .f.

     oCon:= MySql():New()
      IF  oCon:RealConnect(server,username,password,cdb )
                 oTbl := MyResult():New(oCon,,cName)
                 if ! oTbl:OpenRecord()
                      oCon:close()
                      oTbl:close()
                     return

              endif

              LoadFields(aApp,oTbl)

              @  4, 5 DCSAY "Id Codigo       :"   GET  nCodigo     Picture '99999'  GETPOS 4, 19
              @  5, 5 DCSAY "Nombre          :"   GET  cNombre     GETSIZE 35    GETPOS 5, 19
              @  6, 5 DCSAY "Apellidos       :"   GET  cApellidos  GETSIZE 35    GETPOS 6, 19
              @  7, 5 DCSAY "Domicilio       :"   GET  cDomicilio  GETSIZE 25    GETPOS 7, 19
              @  8, 5 DCSAY "Codigo Postal   :"   GET  cPostal     GETSIZE 6     GETPOS 8, 19
              @  9, 5 DCSAY "Localidad       :"   GET  cLocal      GETSIZE 25    GETPOS 9, 19
              @ 10, 5 DCSAY "Provincia       :"   GET  cProvincia  GETSIZE 25    GETPOS 10, 19



          //    @ 14,0 DCPUSHBUTTON CAPTION 'Exit' SIZE 11,1.2 ;                        //exit
          //          ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

             @ 14,13 DCPUSHBUTTON CAPTION 'Next' SIZE 11,1.2 ;                     //next record
                     ACTION {||  oTbl:SKIP(1), LoadFields(aApp,oTbl), DC_GetRefresh(GetList)}

             @ 14,26 DCPUSHBUTTON CAPTION 'Previous' SIZE 11,1.2 ;                    // back record
                     ACTION {||oTbl:SKIP(-1), LoadFields(aApp,oTbl) , DC_GetRefresh(GetList)}

             @ 14,39 DCPUSHBUTTON CAPTION 'Delete' SIZE 11,1.2 ;               //delete
                    ACTION {|| oTbl:Delete() , DC_GetRefresh(GetList)}

             @ 14,52 DCPUSHBUTTON CAPTION 'Save' SIZE 11,1.2 ;                  //save
                     ACTION {|| SaveFields(aApp,oTbl) , DC_GetRefresh(GetList)}

             @ 14,65 DCPUSHBUTTON CAPTION 'Modify' SIZE 11,1.2 ;                //modify
                     ACTION {|| SaveFields(aApp,oTbl) , DC_GetRefresh(GetList)  }

              @ 14,78 DCPUSHBUTTON CAPTION 'New' SIZE 11,1.2 ;                    //new
                     ACTION {|| NewFields(aApp,oTbl) , DC_GetRefresh(GetList)}

        DCGETOPTIONS ;
        AUTORESIZE;

        DCREAD GUI ;
        FIT ;
        OPTIONS GetOptions ;
        BUTTONS DCGUI_BUTTON_EXIT ;
        TITLE 'Test MYSQL'
  endif
        oCon:close()

Return

static function LoadFields(aApp,oTbl)

nCodigo    := oTbl:FieldGet('id_cliente')
cNombre    := oTbl:FieldGet('nombre')
cApellidos := oTbl:FieldGet('apellidos')
cDomicilio := oTbl:FieldGet('domicilio')
cPostal    := oTbl:FieldGet('cpostal')
cLocal     := oTbl:FieldGet('localidad')
cProvincia := oTbl:FieldGet('provincia')

return .t.

static function NewFields(aApp,oTbl)

nCodigo    := 0
cNombre    := space(35)
cApellidos := space(35)
cDomicilio := space(25)
cPostal    := space(6)
cLocalidad := space(25)
cProvincia := space(20)

lNew := .t.

return .t.

static function SaveFields(aApp,oTbl)


oTbl:FieldPut('id_cliente',nCodigo )
oTbl:FieldPut('nombre',cNombre )
oTbl:FieldPut('apellidos',cApellidos)
oTbl:FieldPut('domicilio',cDomicilio)
oTbl:FieldPut('cpostal',cPostal )
oTbl:FieldPut('localidad',cLocal )
oTbl:FieldPut('provincia',cProvincia)

if lNew
    oTbl:Insert()
    lNew := .f.

else
   oTbl:Update()

endif


return .t.


