//  INFOMYSQL.PRG
//
//  INFORMACION DEL DIRECTORIO MYSQL , PARA EXPRESS
//  PUEDE REALIZARSE CONSULTAS, ETC
//  Y SABER LAS BASES DE DATOS Y TABLAS DISPONIBLES
//  SHOW STATUS, SHOW DATAS, SHOW VARIABLES, SHOW TABLES
//  It realizes a query
// Author: Hector Pezoa - `HPGSOFT - 2007
//

#include "dcdialog.ch"         //  esta es para version express
#include "appevent.ch"
#INCLUDE "sqlico.ch"
#INCLUDE "dctree.ch"
#INCLUDE "mysql.ch"


#define aSqlTree       aApp[01]
#define oSqlTree       aApp[02]
#define oTreeA         aApp[03]
#define oTreeB         aApp[04]
#define oDb            aApp[05]
#define oTreeRoot      aApp[06]
#define oMYSQL         aApp[07]
#define oStatic        aApp[08]
#define aInfoDatos     aApp[09]
#define aGetList       aApp[10]
#define oBrowse        aApp[11]
#define cSelected      aApp[12]
#define cUserName      aApp[13]
#define cPassWord      aApp[14]
#define cHost          aApp[15]
#define lConectado     aApp[16]
#define oMsg           aApp[17]
#define cBaseDatos     aApp[18]
#define cTable         aApp[19]


static oConta

PROCEDURE MAIN ()

LOCAL cStatement, nHandle := 0, oToolBar, cDescription,bBlock,;
      GetOptions, oDesc, oBrowseDesc,oParent, aBrowPres, aStru,aApp[20]
Local GetList := {}

//Local  aPP := { { XBP_PP_FGCLR, CRA_CLR_BLUE  }, ;
//         { XBP_PP_BGCLR, GRA_CLR_CYAN }  }

aGetList    := GetList
aInfoDatos  := {}
lConectado  :=  .F.
cUserName   := space(15)
cPassword   := space(15)
cHost       := space(35)
cStatement  := ''

@ 0,3 DCSAY 'Server:   ' GET cHost GETPOS 0,9
@ DCGUI_ROW, DCGUI_COL + 20 DCSAY 'User Name :' Get cUserName
@ DCGUI_ROW, DCGUI_COL + 20 DCSAY 'Password  :' GET cPassword

@ 2,1 DCTREEROOT OBJECT oSqlTree SIZE 25,10 FONT '10.Courier';
      HASLINES HASBUTTONS ;
      ITEMSELECTED {|o| aSelected := o:cargo[3], arbol(aApp,aSelected)}

@ 2.3,30 DCMULTILINE cStatement SIZE 85,8 FONT '10.Courier' //WHEN {||!ADSSQL->(Deleted())}

@ 10.8,33 DCTOOLBAR oToolBar SIZE 80,2.1 BUTTONSIZE 8,2.1

  DCADDBUTTON CAPTION BITMAP_CONECTAR1_32 ;
  TOOLTIP 'connect Server';                      //To connect Server
  ACTION {|| ConnectSQL(aApp)} ;
  PARENT oToolBar

  DCADDBUTTON CAPTION BITMAP_DESCONECTAR1_32 ;
  TOOLTIP 'disconnect Server';                   //to disconnect Server
  PARENT oToolBar

  DCADDBUTTON CAPTION BITMAP_ESTRUCTURA1_32 ;
  TOOLTIP 'SHOW VARIABLES ' ;                       //SHOW VARIABLES
  ACTION {||UpDateVars(aApp)} ;
  PARENT oToolBar

  DCADDBUTTON CAPTION 'Status';
  TOOLTIP 'SHOW STATUS';                          //  SHOW STATUS
  ACTION {||UpdateStatus(aApp)} ;
  PARENT oToolBar

  DCADDBUTTON CAPTION BITMAP_TABLA1_32 ;
  TOOLTIP 'SHOW TABLES' ;                                //SHOW TABLES
  ACTION {||UpdateTable(aApp)} ;
  PARENT oToolBar

  DCADDBUTTON CAPTION BITMAP_BASE1_32 ;
  TOOLTIP 'SHOW DATAS' ;                                //SHOW DATAS
  ACTION {||UpdateData(aApp)} ;
  PARENT oToolBar

  DCADDBUTTON CAPTION BITMAP_CONSULTA1_32 ;
  TOOLTIP 'REALIZES A QUERY' ;              //It realizes a query
  ACTION {||UpdateSql(aApp,cStatement )} ;
  PARENT oToolBar

  DCADDBUTTON CAPTION BITMAP_SALIR1_32 ;
  TOOLTIP 'EXIT ';                                    //EXIT
  ACTION {||DisconnectSql(aApp),DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
  PARENT oToolBar

  @ 13,3 DCSAY 'Result' OBJECT oStatic SIZE 110,10 COLOR GRA_CLR_BLACK, GRA_CLR_WHITE ;
          SAYOPTION XBPALIGN_HCENTER + XBPALIGN_VCENTER + XBPALIGN_WORDBREAK


  @ 23.4,3.5 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX ;
      SIZE 109+1,2+0.4

  @ 23.6,3.9 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT ;
      SIZE 109+0.2,2 ;
      FONT '10.Helv' ;
      OBJECT oMsg   ;
      COLOR GRA_CLR_WHITE , GRA_CLR_DARKGRAY ;
      OPTIONS XBPALIGN_HCENTER+XBPSTATIC_TEXT_WORDBREAK ;
      ID "MY_MSG"

  DCGETOPTIONS ;
  TOOLTIPCOLOR GRA_CLR_BLACK, GRA_CLR_YELLOW ;
  HILITEGETS GRA_CLR_RED ;
  AUTORESIZE

  DCREAD GUI ;
   FIT ;
   OPTIONS GetOptions ;
   TITLE 'CONNECTION MYSQL' ;
   SETAPPWINDOW ;
   EVAL {|o|SetAppWindow(o)}

 RETURN

Procedure ConnectSQL(aApp)
Local j          := 0
Local i          := 0
Local cTxt       := ' '
Local cxBase     := ''
Local cxTable    := ''
Local aNodo      := {}

 IF Empty( cHost ) .AND. Empty( cUserName )
    return
 endif

 cHost       = alltrim(cHost )
 cUserName   = alltrim(cUserName)
 cPassword   = alltrim(cPassword)

   oMYSQL := MySql():New()

   oMsg:setcaption( "Connecting the servER MySql..." )        //Connecting the servER MySql

   IF  oMYSQL:RealConnect(cHost,cUserName,cPassword )
       lConectado := .T.
       cTxt := oMYSQL:cUser + "@" + oMYSQL:cServer

      DCTREEITEM CAPTION cTxt ;
      IMAGENORMAL ICON_CHECKON ;
      IMAGEMARKED ICON_CHECKON ;
      IMAGEEXPANDED ICON_CHECKON ;
      CARGO   aadd(aNodo,{1,nil,nil}) ;
      PARENT oSqlTree  OBJECT oTreeA ;

      FOR i  := 1 TO Len(oMYSQL:aDBases )
      cxBase := oMYSQL:aDBases[i]

         DCTREEITEM CAPTION cxBase ;
         IMAGENORMAL ICON_CHECKON ;
         IMAGEMARKED ICON_CHECKON ;
         IMAGEEXPANDED ICON_CHECKON ;
         CARGO   aadd(aNodo,{2,cxBase,nil}) ;
         PARENT oTreeA  OBJECT oTreeB ;

         oMYSQL:SelectDb( oMYSQL:aDBases[i] )
         oMYSQL:ListTables(oMYSQL:aDBases[i])

                  FOR j := 1 TO Len( oMYSQL:aTables )
                      cxTable := oMYSQL:aTables[j]

                      DCTREEITEM CAPTION  cxTable;
                      IMAGENORMAL ICON_CHECKON ;
                      IMAGEMARKED ICON_CHECKON ;
                      IMAGEEXPANDED ICON_CHECKON ;
                      CARGO aadd(aNodo,{3,cxBase,cxTable});
                      PARENT oTreeB
                  NEXT
       NEXT

      DCREAD GUI EXIT PARENT oSqlTree ;
   //   EVAL {|o| oSqlTree:lockUpdate(.t.), DC_ExpandTree(oSqlTree), oSqlTree:lockUpdate(.f.)}

        UpdateVars(aApp)
        UpdateStatus(aApp)
else
    msgbox('error en comunicacion')            //error in communication
    return
 endif

return

Procedure DisConnectSQL(aApp)

  if lConectado
       oMYSQL:Close()
  endif
  lConectado := .F.

RETURN

//PROCEDURE AppSys()
//RETURN



Function UpdateVars(aApp)
 LOCAL aFila
 Local aHeaders := {'NAME VARIABLE','VALUE'}        // name variable    value
 Local ancho := {25,20}
 LOCAL i

 IF lConectado

    IF len(aInfoDatos )>0
       asize(aInfoDatos,0)
    ENDIF

     oMsg:setcaption( "Execute query: SHOW VARIABLES..." )         //execute query show variables
     aInfoDatos :=  oMYSQL:Show(SHOW_VARIABLES)
     upbrowse(aApp,2,aHeaders,ancho)
 endif

RETURN nil


Function UpdateStatus(aApp)
LOCAL i
LOCAL aFila
Local aHeaders := {'NAME VARIABLE','VALUE'}        //name variable , value
Local ancho := {25,20}

 IF lConectado

    IF len(aInfoDatos )>0
       asize(aInfoDatos,0)
    ENDIF

   oMsg:setcaption( "EXECUTE QUERY: SHOW STATUS..." )
   aInfoDatos :=  oMYSQL:Show(SHOW_STATUS)
   upbrowse(aApp,2,aHeaders,ancho)

endif

RETURN nil

STATIC PROCEDURE UpdateTable( aApp )
LOCAL i ,aInfo :={}
local aCampos := {}
Local aHeaders :=   { "Field", "Type","Null", "Key", "Default Value","Extra" }   //field, type, null, key, default value, extra
Local ancho    :=   {18, 18,7,7,18, 21}


 IF lConectado .AND. !empty(cTable)

       IF len(aInfoDatos )>0
         asize(aInfoDatos,0)
       ENDIF

             oMsg:setcaption( "Execute query: DESCRIBE " + Upper( cTable ) + "..." )   //execute query describe

             oConta := MyResult():New( oMYSQL, "describe " + cTable )
              IF oConta:OpenRecord()
                        oConta:Gotop()
                        FOR i := 1 TO oConta:RecCount()
                         aFila := oConta:LoadData()
                         IF !Empty( aFila[1] )
                              aadd(aInfo,aFila)
                              aadd(aInfoDatos,{ aInfo[i,1],aInfo[i,2],aInfo[i,3],;
                         aInfo[i,4],aInfo[i,5],aInfo[i,6]})
                          ENDIF
                          oConta:Skip(1)
                        NEXT
                ENDIF
                oConta:Close()


      upbrowse(aApp,6,aHeaders,ancho)
 endif
RETURN

STATIC PROCEDURE UpdateData( aApp )
 LOCAL i           := 0
 LOCAL aCampos
 LOCAL aAnchos
 LOCAL aFila
 LOCAL aHeaders    := {}
 LOCAL ancho       := {}
 LOCAL nColumnas   := 0
 LOCAL cTipo ,nLargo , nLargoR ,nSize

  IF lConectado  .AND. !empty(cTable)

      oMsg:setcaption( "Execute query: SELECT * FROM " + Upper( cTable) + " LIMIT 1000..." )  //execute query

      oConta := MyResult():New( oMYSQL, "select * from " + cTable + " limit 1000"  )

        IF oConta:OpenRecord()

                aCampos := ARRAY( oConta:FieldCount() )
                aAnchos := ARRAY( oConta:FieldCount() )

                FOR i := 1 TO oConta:FieldCount()
                        aCampos[i] := oConta:FieldName(i)
                        cTipo :=  oConta:FieldType(i)
                        nLargo := oConta:FieldLen(i)
                        nSize  := len(oConta:FieldName(i))
                         Do Case
                           Case cTipo = "C" .or. cTipo = 'M'
                              if empty(oConta:FieldGet(i))
                                   nLargoR := 1
                               else
                                   nLargoR := len(alltrim(oConta:FieldGet(i)))
                               endif
                               iF nLargoR >= nSize
                                   aAnchos[i] := nLargoR+7
                               else
                                   aAnchos[i] := nSize+4
                               endif
                           Case cTipo = "N"
                               if empty(oConta:FieldGet(i))
                                   nLargoR := 1
                               else
                                   nLargoR := len(alltrim(str(oConta:FieldGet(i))))
                               endif
                              iF nLargoR > nSize
                                   aAnchos[i] := nLargoR -2
                               endif
                               if nSize <= 9
                                  aAnchos[i] := nSize + 2
                               elseif nSize <= 6
                                   aAnchos[i] := nSize +3
                               elseif nSize <= 4
                                    aAnchos[i] := nSize +4
                               else
                                  aAnchos[i] := nSize -2
                               endif
                           Case cTipo = "D"
                               if empty(oConta:FieldGet(i))
                                   nLargoR := 1
                               else
                                   nLargoR := 8
                               endif
                               iF nLargoR >= nSize
                                   aAnchos[i] := nLargoR+4
                               else
                                   aAnchos[i] := nSize+4
                               endif

                           EndCase

                NEXT

       ELSE
          RETURN
       ENDIF

       IF len(aInfoDatos )>0
         asize(aInfoDatos,0)
       ENDIF

       FOR i := 1 TO oConta:FieldCount()
          aadd(aHeaders, aCampos[i])
          aadd(ancho, aAnchos[i])
       NEXT
       nColumnas  := len(aHeaders)

        oConta:GoTop()
        FOR i := 1 TO oConta:RecCount()
           aFila := oConta:LoadData()
           IF !Empty( aFila[1] )
                aadd(aInfoDatos, aFila)
            ENDIF
               oConta:Skip(1)
        NEXT
        oConta:Close()
        upbrowse(aApp,nColumnas,aHeaders,ancho)
   endif
RETURN


STATIC PROCEDURE UpdateSql(aApp,cConsulta)
 LOCAL i
 LOCAL aCampos
 LOCAL aAnchos
 LOCAL aFila
 LOCAL nTiempo1
 LOCAL nTiempo2
 LOCAL cTexto
 LOCAL nColumnas
 LOCAL aHeaders    := {}
 LOCAL ancho       := {}
 Local nLargo

        IF Empty( cConsulta )
                MsgBox( "Error - No hay una consulta" )             //error - no query
                RETURN
        ENDIF

        nTiempo1 := Seconds()
        oConta := MyResult():New( oMYSQL, cConsulta )
        IF oConta:OpenRecord()
                nTiempo2 := Seconds()
                cTexto := AllTrim( Str( oConta:RecCount() ) ) + " records "             //record
                cTexto += " en " + PadR( nTiempo2 - nTiempo1, 6, "0" ) + " seconds"      // seconds

                oMsg:setcaption(cTexto)
                aCampos := ARRAY( oConta:FieldCount() )
                aAnchos := ARRAY( oConta:FieldCount() )

                 FOR i := 1 TO oConta:FieldCount()
                        aCampos[i] := oConta:FieldName(i)

                        cTipo :=  oConta:FieldType(i)
                        nLargo := oConta:FieldLen(i)
                        nSize  := len(oConta:FieldName(i))
                          Do Case
                           Case cTipo = "C" .or. cTipo = 'M'
                              if empty(oConta:FieldGet(i))
                                   nLargoR := 1
                               else
                                   nLargoR := len(alltrim(oConta:FieldGet(i)))
                               endif
                               iF nLargoR >= nSize
                                   aAnchos[i] := nLargoR+4
                               endif

                               if nSize <= 6
                                   aAnchos[i] := nSize+ 6
                               elseif nSize <= 4
                                    aAnchos[i] := nSize +7
                               endif
                           Case cTipo = "N"
                               if empty(oConta:FieldGet(i))
                                   nLargoR := 1
                               else
                                   nLargoR := len(alltrim(str(oConta:FieldGet(i))))
                               endif

                               iF nLargoR >= nSize
                                   aAnchos[i] := nLargoR -2
                               endif
                               if nSize <= 9
                                  aAnchos[i] := nSize +2
                               elseif nSize <= 6
                                   aAnchos[i] := nSize +3
                                elseif nSize <= 4
                                    aAnchos[i] := nSize +4
                                else
                                  aAnchos[i] := nSize -2
                               endif
                                 Case cTipo = "D"
                               if empty(oConta:FieldGet(i))
                                   nLargo := 1
                               else
                                   nLargoR := 8
                               endif
                               iF nLargoR >= nSize
                                   aAnchos[i] := nLargoR+4
                               else
                                   aAnchos[i] := nSize+4
                               endif
                           EndCase
              NEXT

        ELSE
             RETURN
        ENDIF

       IF len(aInfoDatos )>0
         asize(aInfoDatos,0)
       ENDIF

       FOR i := 1 TO oConta:FieldCount()
          aadd(aHeaders, aCampos[i])
          aadd(ancho, aAnchos[i])
       NEXT
       nColumnas  := len(aHeaders)


       FOR i := 1 TO oConta:RecCount()
            aFila := oConta:LoadData()
           IF !Empty( aFila[1] )
                aadd(aInfoDatos, aFila)
            ENDIF
               oConta:Skip(1)
        NEXT

        oConta:Close()
        upbrowse(aApp,nColumnas,aHeaders,ancho)

RETURN

FUNCTION upbrowse(aApp,nColumna,aHead,ancho)
Local nNumFields, bData, cFieldName, i := 1, GetList[0]  , ;
      nLength,cCabeza, nPointer := 1

IF Valtype(oBrowse) = 'O'
  DC_GetDestroy(aGetList,'BROWSE')
  oBrowse := nil
ENDIF

 IF len(aInfoDatos )>0
    nLength := len(aInfoDatos)

 ENDIF

bData := aInfoDatos

@ 0,0 DCBROWSE oBrowse ;
      PIXEL ;
      GROUP 'BROWSE' ;
      DATA bData ;
      POINTER nPOINTER;
      EDIT xbeBRW_ItemSelected ;
      SIZE oStatic:currentSize()[1], oStatic:currentSize()[2] ;
      PRESENTATION DC_BrowPres()

      FOR i = 1 TO nColumna

      DCBROWSECOL ELEMENT i PARENT oBrowse ;
      HEADER aHead[i] width ancho[i] ;
      FONT "8.Courier New"  ;

      NEXT

      oStatic:hide()

      DCREAD GUI ;
      PARENT oStatic ;
      EXIT ;
      _SAVE .T.
      oStatic:show()

      DC_MergeGetLists(aGetList,GetList)


     RETURN .T.


Static Procedure arbol(aApp,aSel)
Local nodo := aSel[1]

 cBaseDatos  := aSel[2]
 cTable      := aSel[3]
    Do case
      case  nodo = 1
         ArbolChange(1, aApp)
      case  nodo = 2
         ArbolChange(2, aApp)
      case  nodo = 3
        ArbolChange(3, aApp)
      othe
          return
    endcase

return



STATIC PROCEDURE ArbolChange(nItem, aApp)
Local aRegistros

        DO CASE
        CASE nItem = 1
                oMsg:setcaption("The server it contains " + AllTrim( Str( Len( oMYSQL:aDBases ) ) ) + " basesdatos" )      //server it contains basedatos

        CASE nItem = 2
               oMYSQL:ListTables( cBaseDatos )
                oMsg:setcaption( "The basedatos " + Upper( cBaseDatos ) + "it contains " + AllTrim( Str( Len( oMYSQL:aTables ) ) ) + " tables" )  //basedatos it contains tables
        CASE nItem = 3
               oMYSQL:ListTables( cBaseDatos )
              oMsg:setcaption( "The basedatos " + Upper( cBaseDatos ) + " it contains " + AllTrim( Str( Len( oMYSQL:aTables ) ) ) + " tables" ) //basedatos it contains tables

              oMYSQL:SelectDB( cBaseDatos )
              UpdateTable(aApp )
              UpdateData(aApp )

              oConta := MyResult():New( oMYSQL, "select count(*) from " + cTable )

               IF oConta:OpenRecord()
                        oConta:Gotop()
                        aRegistros := oConta:LoadData()
                        oMsg:setcaption( "The table " + Upper( cTable ) + "it contains " + AllTrim(str(aRegistros[1]))  + " records" )  //table it contains  records
                        oConta:Close()
              ELSE
                 RETURN
              ENDIF

        ENDCASE


RETURN