*--------------------------------------------------------*
* Ejemplo de como meter una imagen en un blob de MySQL   *
*																			*
* Autor: Jose Alfonso Surez Moreno	(jasm@chochurro.com)	*
* Fecha: 26.11.2004													*
* 																			*
* Este ejemplo no se puede ejecutar tal como esta, hay   *
* que realizar las conexiones con MySQL.						*
*																			*
*--------------------------------------------------------*

FUNCION Main()

	LOCAL cImagen

	// Hacer todo lo necesario para conectar con el servidor MySQL, etc.

	IF (cImagen	:= Img2Men( "MiDibujo.jpg" ) ) <> .F.

		cQuery := "INSERT INTO tabla ( imagen ) VALUES ( " + cImagen + ")"

		MSQuery( nConex, cQuery )

	END IF

	QUIT

RETURN NIL



FUNCTION Img2Men( cImg )

	// Pone el contenido de cualquier fichero en una variable de memoria.

	// cImg contiene el nombre del fichero de imagen con extension. Especificar path absoluto.
	// La funcion devuelve .F. si se produce algun error y una cadena con el contenido del
	// fichero de imagen.

	// Ver manual de Clipper para mas informacion sobre funciones
	// fopen(), fseek(), fread(), fclose()

	LOCAL nMani
	LOCAL cVarImg	:= ""
	LOCAL nPos		:= 0
   LOCAL nSize     := 0
	LOCAL nRead		:= 0

	nMani := fopen( cImg )

	IF ferror() <> 0
		? "Error de apertura de fichero DOS " + Str( ferror() )
		RETURN .F.
	ELSE
		nTam := fseek( nMani, 0, FS_END )			&& averiguar tamao del fichero.
		fseek( nMani, 0 )									&& situar el puntero al principio del fichero.
		nRead := fread( nMani, @cVarImg, nTam )   && Leer el fichero.
		IF nRead <> nTam
			? "No corresponden los bytes leidos con el tamao pedido"
			fclose( nMani )
			RETURN .F.
		END IF

	END IF

	fclose( nMani )

RETURN cVarImg





